#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>
#define THERMISTORPIN A1
#define THERMISTORNOMINAL 10000.0
#define TEMPERATURENOMINAL 25.0
#define NUMSAMPLES 10.0
#define BCOEFFICIENT 3950.0
#define SERIESRESISTOR 10000.0
#define LIGHTSENSOR A2
#define WATERSENSOR A4

LiquidCrystal_I2C lcd(0x3F, 16, 2);
uint16_t samples[(int)NUMSAMPLES];
Adafruit_BMP280 bmp;
char c;

void setup() {
  // put your setup code here, to run once:
  lcd.init();
  c = ' ';
  lcd.begin(16, 2);
  lcd.backlight();
  lcd.setCursor(0, 0);
  lcd.print("Hello there!");
  delay(1000);
  Serial.begin(9600);
  bmp.begin(0x76);
}

void loop() {
  // put your main code here, to run repeatedly:
  if (Serial.available()) {
    char a = Serial.read();
    char buf[20];
    if(a != '\n') {
      c = a;
    }
  }
  if(c == 't') {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print(F("Temperature:"));
    lcd.setCursor(0, 1);
    lcd.print(bmp.readTemperature());
    lcd.print("*C");

    // sensorul de lumina
    // uint8_t i;
    // float pressure;
    // float average;
    // float temperature;
    //  for(i = 0; i < NUMSAMPLES; i++) {
    //   samples[i] = analogRead(THERMISTORPIN);
    //   delay(10);
    // }
    // average = 0;
    // for(i = 0; i < NUMSAMPLES; i++) {
    //   average += samples[i];
    // }
    // average /= NUMSAMPLES;
    // float resistance = SERIESRESISTOR * (1023.0 / average - 1.0);

    // temperature = TEMPERATURENOMINAL + (1.0 / (log(resistance / THERMISTORNOMINAL) / BCOEFFICIENT + 1.0 / (TEMPERATURENOMINAL + 273.15))) - 273.15;
    // lcd.print(temperature);
    // lcd.print(" *C");
    delay(2000);
    
  } else if(c == 'w') {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Water level:");
    lcd.setCursor(0, 1);
    int waterValue = analogRead(WATERSENSOR);
    if(waterValue < 300) {
      lcd.print("HIGH");
    } else if(waterValue > 300 && waterValue < 700) {
      lcd.print("MID");
    } else {
      lcd.print("LOW");
    }
    delay(2000);

  } else if(c == 'p') {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print(F("Pressure:"));
    lcd.setCursor(0, 1);
    lcd.print(bmp.readPressure() * 0.00750062);
    lcd.print("mmHg");
    delay(2000);

  } else if(c == 'l') {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("UV level:");
    lcd.setCursor(0, 1);
    int lightValue = analogRead(LIGHTSENSOR);
    if(lightValue < 200) {
      lcd.print("LOW");
    } else if(lightValue >= 200 && lightValue < 400) {
      lcd.print("MEDIUM");
    } else if(lightValue >= 400 && lightValue < 600) {
      lcd.print("HIGH");
    } else {
      lcd.print("VERY HIGH");
    }
    
    delay(2000);

  } else if(c == ' ') {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Type a command");
    lcd.setCursor(0, 1);
    lcd.print("Commands:t,w,p,l");
    delay(2000);

  } else {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Invalid command");
    lcd.setCursor(0, 1);
    lcd.print("Commands:t,w,p,l");
    delay(2000);
  }

}
